'FreeBASIC
'Very bad example code, but a very good compiler.

#include "fbgfx.bi"
#include "GL/gl.bi"
#include "GL/glext.bi"
#include "GL/glu.bi"

const as integer scr_w = 1024, scr_h = 768
const as integer iWidth = 64, iHeight = 64
const as single pi = 3.1415926, pi_2 = pi*2, pi_180 = pi/180, inv_pi_180 = 180/pi

'the minimum for framebuffer objects
common shared _framebuffer_                    as integer
common shared glGenFramebuffersEXT             as PFNglGenFramebuffersEXTPROC
common shared glDeleteFramebuffersEXT          as PFNglDeleteFramebuffersEXTPROC
common shared glBindFramebufferEXT             as PFNglBindFramebufferEXTPROC
common shared glFramebufferTexture2DEXT        as PFNglFramebufferTexture2DEXTPROC
common shared glFramebufferRenderbufferEXT     as PFNglFramebufferRenderbufferEXTPROC
common shared glGenRenderbuffersEXT            as PFNglGenRenderbuffersEXTPROC
common shared glBindRenderbufferEXT            as PFNglBindRenderbufferEXTPROC
common shared glRenderbufferStorageEXT         as PFNglRenderbufferStorageEXTPROC
common shared glDeleteRenderbuffersEXT         as PFNglDeleteRenderbuffersEXTPROC
common shared glCheckFramebufferStatusEXT      as PFNglCheckFramebufferStatusEXTPROC
common shared glGenerateMipmapEXT              as PFNglGenerateMipmapEXTPROC

randomize timer

type Rgbalpha
    as single R,G,B,A
end type

type vec3f
	as single x, y, z
	declare operator cast() as string
end type

type vec4f
	as single x, y, z, w
	declare operator cast() as string
end type


type snake_struct
	posit   	as vec3f
	mdir    	as vec3f
	scale		as single
end type

type pellet_struct
	posit   as vec3f
	value   as integer
end type


type render_target_struct

	fBuffer as GLUINT
	dBuffer as GLUINT
	texture as GLUINT
	width as uinteger
	height as uinteger

	declare function create ( byref w as uinteger, byref h as uinteger, byref has_depth as integer, byref has_stencil as integer  ) as integer
	declare sub destroy()
	declare sub lock()
	declare sub unlock()

end type

type Light_Struct

	Ambient             as RGBAlpha
	Diffuse             as RGBAlpha
	Specular            as RGBAlpha
	Position            as vec4f
	Direction           as vec3f

end type

declare function spawn( snake() as snake_struct ) as integer
declare function respawn( snake() as snake_struct ) as integer
declare function spawn_pellet( byref pellet as pellet_struct, byref min as vec3f, byref max as vec3f, snake() as snake_struct ) as integer
declare sub create_gl_context()
declare sub set_ortho( byval W as integer, byval H as integer )
declare sub drop_ortho()
declare sub create_font_dlist( byref DList as GlUINT,  byval Wtiles as single, byval Htiles as single, byval t_Scale as integer )
declare sub glprint3d( byref Strng as string, byval Texture as GLUINT, byval Text_List as GLUINT, byval X as single, byval Y as single, byval z as single, byval R as single, byval G as single, byval B as single )
declare sub texture_from_fbimage( byref texture as gluint, byref textptr as any ptr )
declare sub gen_textures( textures() as gluint, iptrs() as fb.image ptr )
declare sub blur_image( byref dst as FB.IMAGE ptr, byref src as FB.IMAGE ptr, byref blur_level as integer )
declare sub switcho_chango( snake() as snake_struct, byref mdir as vec3f )
declare sub gather_extensions()
declare sub init_light( byref light as Light_Struct, byref ambient as RGBALpha, byref diffuse as RGBAlpha, byref specular as RGBAlpha, byref position as vec4f, byref direction as vec3f )


dim shared as integer fnum

dim as gluint flist, textures(4)
dim as any ptr iptrs(ubound(textures))
dim as vec3f mdir = (2,0,0), last_posit
dim as integer mousex, mousey, mouseb
dim as single xangle, yangle, xcam, ycam, zcam, do_switch, dist
dim as double ftime, ltime, ttime, mtime, squigT
dim as pellet_struct pellet
dim as snake_struct snake()
dim as integer use_fbo= true, use_cylinder = true
dim as integer head_rot
dim as render_target_struct frameBuffer
dim as light_struct light
dim as integer has_played
dim as integer squigLR, squigUD
dim as single squiggle


create_gl_context()

gen_textures( textures(), iptrs() )

frameBuffer.create( 512, 256, 0, 0 )

init_light( light, type(.4,.4,.4,1f), type(.5,.5,.5,1f), type(.65,.65,.65,1f), type(0f,0f,50f,1f), type(0f,1f,0f) )

for i as integer = 0 to ubound(textures)
	texture_from_fbimage( textures(i), iptrs(i) )
	imagedestroy( iptrs(i) )
next

create_font_dlist( flist, 16, 16, 8 )
glDisable( GL_CULL_FACE )


start_over:
squigUD = true
glDisable( GL_LIGHTING )
glDisable( GL_DEPTH_TEST)

do

	set_ortho(scr_w, scr_h)
	glClear(GL_COLOR_BUFFER_BIT)

	glprint3d( "Snakes on a cylinder!", textures(0), flist, scr_w/2-len("Snakes on a cylinder!")*8, scr_h/2, 0, 1,1,0 )
	glprint3d( "Press Space to play...", textures(0), flist, scr_w/2-len("Press Space to play...")*8, scr_h/2-20, 0, 1,1,0 )
	glprint3d( "Press Escape to exit...", textures(0), flist, scr_w/2-len("Press Escape to exit...")*8, scr_h/2-40, 0, 1,1,0 )

	if has_played then
		dim as string text = "Previous score " & ubound(snake)
		glprint3d( text, textures(0), flist, scr_w/2-len(text)*8, scr_h/2-60, 0, .5+.25*sin(timer*20),0,0 )
	end if

	drop_ortho()

	if multikey(FB.SC_ESCAPE) then
		end
	end if

	flip
	sleep 3,1

loop until multikey(FB.SC_SPACE)


head_rot = 0
mdir = type(2,0,0)
respawn( snake() )
spawn_pellet( pellet, type(0,24,0), type(framebuffer.width-24, framebuffer.height-48,0), snake() )
ftime = timer
has_played = -1

do

	ltime = timer - ftime
	ftime = timer
	
	SquigT+=lTime
	squiggle = .5*sin(squigT*20)
	
	if squigUD then
		mdir.y=squiggle
	end if
		
	if squigLR then
		mdir.x=squiggle			
	end if
	
	getmouse(mousex, mousey,, mouseb )

	xcam = -snake(0).posit.x
	ycam = -snake(0).posit.y
	dim as single zoom = dist*(dist*1.25)
	dim as single scalar = 8

	if zcam<zoom then
		zcam+=lTime*150
	end if

	if zcam>zoom then
		zcam-=lTime*150
	end if

	if zcam>100 then
		zcam = 100
	end if
	if zcam<30 then
		zcam = 30
	end if

	'if multikey(FB.SC_F) then

	'	use_fbo = not use_fbo

	'	do
	'		screencontrol FB.Poll_events
	'		sleep 3, 1
	'	loop while multikey(FB.SC_F)

	'end if


	'if multikey(FB.SC_C) then

	'	use_cylinder = not use_cylinder

	'	do
	'		screencontrol FB.Poll_events
	'		sleep 3, 1
	'	loop while multikey(FB.SC_C)

	'end if


	if do_switch = 0 then
		
		if int(last_posit.x)<>int(snake(0).posit.x) or int(last_posit.y)<>int(snake(0).posit.y) then
			last_posit = snake(0).posit
			

			if multikey(FB.SC_UP) then

				if mdir.y = -2 then
					switcho_chango( snake(), mdir )
					do_switch = .1
				else
					mdir = type(0,2,0)
				end if

				head_rot = 90
				squigLR = true
				squigUD = false
				
			end if


			if multikey(FB.SC_DOWN) then

				if mdir.y = 2 then
					switcho_chango( snake(), mdir )
					do_switch = .1
				else
					mdir = type(0,-2,0)
				end if

				head_rot = 270
				squigLR = true
				squigUD = false

			end if


			if multikey(FB.SC_RIGHT) then

				if mdir.x = -2 then
					switcho_chango( snake(), mdir )
					do_switch = .1
				else
					mdir = type(2,0,0)
				end if

				head_rot = 0
				squigLR = false
				squigUD = true
				
			end if


			if multikey(FB.SC_LEFT) then

				if mdir.x = 2 then
					switcho_chango( snake(), mdir )
					do_switch = .1
				else
					mdir = type(-2,0,0)
				end if

				head_rot = 180
				squigLR = false
				squigUD = true
				
			end if

			dim as snake_struct tsnake( ubound(snake) )

			if fTime>mtime then

				mtime = fTime+.045

				for i as integer = 0 to ubound(snake)
					tsnake(i) = snake(i)
				next

				for i as integer = 1 to ubound(snake)
					snake(i) = tsnake(i-1)
				next

			end if

		end if

		for i as integer = 1 to ubound(snake)
			snake(i).scale = 1f-(.5f*(i/ubound(snake)))
		next
		
		snake(0).posit.x +=(mdir.x*(ltime*50))
		snake(0).posit.y +=(mdir.y*(ltime*50))
		
		snake(0).mdir = mdir


		if snake(0).posit.y < (scalar+10) then
			'respawn( snake() )
			'spawn_pellet( pellet, type(0,24,0), type(framebuffer.width-24, framebuffer.height-48,0), snake() )
			goto start_over
		end if

		if snake(0).posit.y > framebuffer.height-(scalar+10) then
			'respawn( snake() )
			'spawn_pellet( pellet, type(0,24,0), type(framebuffer.width-24, framebuffer.height-48,0), snake() )
			goto start_over
		end if

		if snake(0).posit.x+scalar*2 <= 0 then
			snake(0).posit.x += framebuffer.width
		end if

		if snake(0).posit.x-scalar*2 >= framebuffer.width then
			snake(0).posit.x -= framebuffer.width
		end if

		if ubound(snake)>1 then
			for i as integer = 2 to ubound(snake)
				dim as single dist = (snake(0).posit.y-snake(i).posit.y)^2 + (snake(0).posit.x-snake(i).posit.x)^2
				if dist<scalar then
					goto start_over
					'respawn( snake() )
					'spawn_pellet( pellet, type(0,24,0), type(framebuffer.width-24, framebuffer.height-48,0), snake() )
					'ttime = timer+1
					'exit for
				end if
			next
		end if

		dist = sqr( (snake(0).posit.y-pellet.posit.y)^2 + (snake(0).posit.x-pellet.posit.x)^2 )

		if dist < = scalar*2 then
			for i as integer = 1 to pellet.value
				spawn( snake() )
			next
			spawn_pellet( pellet, type(0,24,0), type(framebuffer.width-24, framebuffer.height-48,0), snake() )
		end if

	end if


	'offscreen drawing starts here________________________________________________________
	if use_fbo then
		frameBuffer.Lock()
	end if


	set_ortho(framebuffer.width, framebuffer.height)
	glClear( GL_COLOR_BUFFER_BIT)
	glDisable( GL_LIGHTING )
	glDisable( GL_LIGHT0 )

	'draw the big background quad
	glBindTexture( GL_TEXTURE_2D, textures(4) )
	glEnable( GL_TEXTURE_2D )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST )
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
	glDisable( GL_BLEND )
	glColor3f(1,1,1)

	glBegin( GL_QUADS )
	glTexCoord2f(0,1)
	glVertex2f( 0,framebuffer.height)

	glTexCoord2f(0,0)
	glVertex2f(0,0)

	glTexCoord2f(1,0)
	glVertex2f(framebuffer.width, 0)

	glTexCoord2f(1, 1)
	glVertex2f( framebuffer.width, framebuffer.height)
	glEnd()


	'draw the brick textures along the top and bottom of the buffer
	glBindTexture( GL_TEXTURE_2D, textures(3) )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR )
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
	dim as integer tsz = 8

	for y as integer = tsz to framebuffer.height-tsz step framebuffer.height-(tsz*2)
		for x as integer = 0 to framebuffer.width step tsz*2

			if x = 0 or y = tsz or x = framebuffer.width or y = framebuffer.height-tsz then

				glColor3f(1,1,1)
				glBegin( GL_QUADS )
				glTexCoord2f(0,1)
				glVertex2f( x-tsz, y+tsz)

				glTexCoord2f(0,0)
				glVertex2f( x-tsz, y-tsz)

				glTexCoord2f(1,0)
				glVertex2f( x+tsz, y-tsz)

				glTexCoord2f(1,1)
				glVertex2f( x+tsz, y+tsz)
				glEnd()

			end if

		next
	next

	'use the print function to draw the texture of pellet.value now... flist is a display list, textures(0) is the actual font texture
	dim as single tCol = .5+.5*sin(timer*20)
	glprint3d( str(pellet.value), textures(0), flist, pellet.posit.x, pellet.posit.y, 0, tCol,tCol,tCol )



	'draw the snake body now... we do a bit of interpolation here, but nothing to be concerned with
	'it just makes the snake look nice and stops the wrapping from looking all weird
	glBindTexture( GL_TEXTURE_2D, Textures(1) )
	glEnable( GL_TEXTURE_2D )
	glEnable( GL_BLEND )
	'glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
	glColor3f(1,1,1)

	if do_switch>0 then
		do_switch+=ltime*100
		if do_switch>50 then
			do_switch = 0
		end if
	end if


	dim as integer worm_segments = 4

	for i as integer = ubound(snake) - 1 to 0 step -1

		dim as integer dSide, runs

		if snake(i).posit.x<=(scalar*2) then

			dSide = framebuffer.width
			runs = 1

		elseif snake(i).posit.x>=framebuffer.width-(scalar*2) then

			dSide = -framebuffer.width
			runs = 1

		end if

		scalar = 8

		for d as integer = 0 to runs

			if do_switch>0 then
				if ubound(snake)-i = int(ubound(snake)*(int(do_switch)/50)) then
					scalar = 1+do_switch/50
				end if
			end if

			dim as single p1x = snake(i).posit.x+(dSide*d)
			dim as single p1y = snake(i).posit.y
			dim as single p2x = snake(i+1).posit.x+(dSide*d)
			dim as single p2y = snake(i+1).posit.y
			dim as single xinc = (p2x-p1x) / worm_segments
			dim as single yinc = (p2y-p1y) / worm_segments
			dim as single positx = p2x
			dim as single posity = p2y


			'if the distance between segments is large...
			if abs(p2x-p1x) > 100 then

				if p2x > p1x then

					p2x = p1x-worm_segments
					positx = p2x
					xinc = (p2x-p1x) / worm_segments

				elseif p2x<p1x then

					p2x = p1x+worm_segments
					positx = p2x
					xinc = (p2x-p1x) / worm_segments

				end if

			end if

			for c as integer = 1 to worm_segments

				if positx+scalar*2 <= 0 then
					positx += framebuffer.width
				end if

				if positx-scalar*2 >= framebuffer.width then
					positx -= framebuffer.width
				end if

				positx-=xinc
				posity-=yinc

				glPushMatrix()
				glTranslatef(positx, posity, 0)

				if i = 0 then
					glBindTexture( GL_TEXTURE_2D, Textures(2) )
					glRotatef( head_rot, 0, 0, 1 )
				else
					glColor3f(1,1,1)
					glScaleF( snake(i).scale, snake(i).scale, 1)
				end if


				glBegin( GL_QUADS )
				glTexCoord2f(0,1)
				glVertex2f( -scalar, scalar)

				glTexCoord2f(0,0)
				glVertex2f( -scalar, -scalar)

				glTexCoord2f(1,0)
				glVertex2f( scalar, -scalar)

				glTexCoord2f(1,1)
				glVertex2f( scalar, scalar)
				glEnd()
				glPopMatrix()

			next

		next

	next

	drop_ortho()

	if use_fbo then

		frameBuffer.Unlock()

		'set the viewport back to 3d mode, create a cylinder model and plaster the render texture to it
		glEnable( GL_LIGHTING )
		GlEnable( GL_LIGHT0 )
		glDisable( GL_BLEND )

		glEnable( GL_DEPTH_TEST )
		glDepthFunc( GL_LESS )
		glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )

		glMatrixMode(GL_PROJECTION)
		glLoadIdentity()
		gluPerspective( 60, scr_w/scr_h, .1, 500 )

		glMatrixMode( GL_MODELVIEW )
		glLoadIdentity()
		gluLookAt( 0,0,22, 0,0,0, 0,1,0)

		glEnable( GL_LIGHTING )
		glEnable( GL_LIGHT0 )
		glLightfv( GL_LIGHT0, GL_POSITION, @light.position.x )
		gllightfv( GL_LIGHT0, GL_AMBIENT, @light.ambient.r )
		gllightfv( GL_LIGHT0, GL_DIFFUSE, @light.diffuse.r )
		gllightfv( GL_LIGHT0, GL_SPECULAR, @light.specular.r )
		gllightfv( GL_LIGHT0, GL_POSITION, @light.position.x )



		dim as rgbalpha amb = type(.35,.35,.35,1)
		dim as rgbalpha dif = type(.45,.45,.45,1)
		dim as rgbalpha spe = type(.25,.25,.25,1)


		glColor4f(1, 1, 1, 1)
		glEnable( GL_TEXTURE_2D )
		glBindTexture( GL_TEXTURE_2D, frameBuffer.texture )
		glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE )
		glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE )
		glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR )
		glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR )
		glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)

		if use_cylinder then

			glrotatef((-yCam-(framebuffer.height/2))/3,1,0,0)
			glrotatef((xcam*.705)-90,0,1,0)

			glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT,   @amb.r )
			glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE,   @dif.r )
			glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR,  @spe.r )
			glMaterialf ( GL_FRONT_AND_BACK, GL_SHININESS, 32 )

            
			dim as single zStep = 360/36
         'dim as single oddBallTimer=zStep, _oddBallTimer
            
			for z as integer = 0 to 360-zStep step zStep

				dim as single tc1 = cos(z*pi_180)
				dim as single ts1 = sin(z*pi_180)
				dim as single tc2 = cos((z+zStep)*pi_180)
				dim as single ts2 = sin((z+zStep)*pi_180)
                
                dim as single ox1 = 5' + 1.5 * cos(_oddBallTimer*pi_180)
                dim as single oz1 = 5' + 1.5 * sin(_oddBallTimer*pi_180)
                dim as single ox2 = 5' + 1.5 * cos(oddBallTimer*pi_180)
                dim as single oz2 = 5' + 1.5 * sin(oddBallTimer*pi_180)
                
                '_oddBallTimer = oddBallTimer
                'oddBallTimer+=((360*9)/zStep)
                
				dim as vec3f p1 = type(ox1*tc1,10,oz1*ts1)
				dim as vec3f p2 = type(ox2*tc2,10,oz2*ts2)
				dim as vec3f p3 = type(ox2*tc2,-10,oz2*ts2)
				dim as vec3f p4 = type(ox1*tc1,-10,oz1*ts1)

				dim as vec3f n1 = type( p2.x-p1.x, p2.y-p1.y, p2.z-p1.z )
				dim as vec3f n2 = type( p3.x-p1.x, p3.y-p1.y, p3.z-p1.z )

				dim as vec3f pNormal = type( (n1.y * n2.z) - (n2.y * n1.z), (n1.z * n2.x) - (n2.z * n1.x), (n1.x * n2.y) - (n2.x * n1.y) )
				dim as single magnitude = 1f/sqr(pNormal.x ^2 + pNormal.y ^2 + pNormal.z ^2)
				pNormal.x*=magnitude
				pNormal.y*=magnitude
				pNormal.z*=magnitude

				dim as single z1 = 1f-(z/360f)
				dim as single z2 = 1f-((z+zStep)/360f)



				glBegin( GL_QUADS)

				glNormal3fv(@pNormal.x)

				glTexCoord2f(z1,1)
				glVertex3fv(@p1.x)

				glTexCoord2f(z2,1)
				glVertex3fv(@p2.x)

				glTexCoord2f(z2,0)
				glVertex3fv(@p3.x)

				glTexCoord2f(z1,0)
				glVertex3fv(@p4.x)

				glEnd()

			next

			set_ortho(scr_w, scr_h)
			dim as string text = "Your score " & ubound(snake)
			glDisable( GL_LIGHTING)
			glprint3d( text, textures(0), flist, scr_w/2-len(text)*8, scr_h-8, 0, 1,1,1 )
			glEnable( GL_LIGHTING)
			drop_ortho()

		else

			glDisable( GL_LIGHTING )
			glBegin( GL_QUADS )

			glNormal3f( 0, 0, 1 )

			glTexCoord2f(0,1)
			glVertex3f( -14, 7, 0 )

			glTexCoord2f(0,0)
			glVertex3f( -14, -7, 0 )

			glTexCoord2f(1,0)
			glVertex3f( 14, -7, 0 )

			glTexCoord2f(1,1)
			glVertex3f( 14, 7, 0 )

			glEnd()


		end if

	else

	end if

	flip

	sleep 3,1

loop until multikey( FB.SC_ESCAPE )

close #fnum


sub switcho_chango( snake() as snake_struct, byref mdir as vec3f )

	dim as snake_struct tsnake( ubound(snake) )

	mdir.x = -snake(ubound(snake)).mdir.x
	mdir.y = -snake(ubound(snake)).mdir.y

	for i as integer = 0 to ubound(snake)
		tsnake(i) = snake(i)
	next

	for i as integer = 0 to ubound(snake)
		snake(i) = tsnake( ubound(snake) - i )
	next

end sub


function respawn( snake() as snake_struct ) as integer

	redim snake(1)

	snake(0).posit = type(256,128)
	snake(1).posit = type(256,128)

	return 0

end function


function spawn( snake() as snake_struct ) as integer

	redim preserve snake( ubound(snake) + 1 )

	snake(ubound(snake)).posit = type(-1000,-1000,0)

	return 0

end function

function spawn_pellet( byref pellet as pellet_struct, byref min as vec3f, byref max as vec3f, snake() as snake_struct ) as integer

	randpellet:

	pellet.posit.x = min.x + rnd * max.x
	pellet.posit.y = min.y + rnd * max.y
	pellet.posit.z = 0
	pellet.value = 1 + int(rnd*9)

	for i as integer = 0 to ubound(snake)
		if abs(int(pellet.posit.x) - int(snake(i).posit.x))<2 and abs(int(pellet.posit.y) - int(snake(i).posit.y)) < 2 then
			goto randpellet
		end if
	next

	return 0

end function


sub create_font_dlist( byref DList as GlUINT,  byval Wtiles as single, byval Htiles as single, byval t_Scale as integer )

	DList = glGenLists(256)
	dim as integer i
	dim as single Tx, Ty, XStepp = 1/Wtiles, YStepp = 1/Htiles
	glMatrixMode( GL_MODELVIEW )
	glLoadIdentity()
	glPushMatrix()
	i=0
	for TY as integer = Htiles-1 to 0 step -1
		for TX as integer = 0 to Wtiles-1

			glNewList( DList+i, GL_COMPILE )
			glBegin( GL_QUADS )

			glTexCoord2f( Tx*XStepp, (Ty+1)*YStepp )
			glVertex2i( -t_Scale, t_Scale )

			glTexCoord2f( Tx*XStepp, Ty*YStepp )
			glVertex2i( -t_Scale, -t_Scale )

			glTexCoord2f( (Tx+1)*XStepp, Ty*YStepp )
			glVertex2i( t_Scale, -t_Scale )

			glTexCoord2f( (Tx+1)*XStepp, (Ty+1)*YStepp )
			glVertex2i( t_Scale, t_Scale )

			glEnd()

			glTranslatef( t_Scale*2, 0, 0 )

			glEndList()
			i+=1

		next
	next
	glPopMatrix()

end sub

sub glprint3d( byref Strng as string, byval Texture as GLUINT, byval Text_List as GLUINT, byval X as single, byval Y as single, byval z as single, byval R as single, byval G as single, byval B as single )

	dim as integer Length = len(Strng)

	glBindTexture( GL_TEXTURE_2D, Texture )
	glEnable( GL_TEXTURE_2D )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST )
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)

	glEnable( GL_BLEND )
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
	glPolygonMode ( GL_FRONT_AND_BACK, GL_FILL )

	glPushMatrix()

	glTranslatef( X, Y, Z )
	glColor3d( R,G,B )
	glListBase( Text_List )
	glCallLists( Length, GL_UNSIGNED_BYTE, strptr(Strng) )

	glPopMatrix()

	glDisable( GL_BLEND )
	glDisable( GL_TEXTURE_2D )

end sub


sub texture_from_fbimage( byref texture as gluint, byref textptr as any ptr )

	dim as fb.image ptr timage = cast( fb.image ptr, textptr )

	glGenTextures(1, @texture)
	glBindTexture( GL_TEXTURE_2D, texture )
	glEnable( GL_TEXTURE_2D )
	glTexImage2d( GL_TEXTURE_2D, 0, GL_RGBA, timage->width, timage->height, 0, GL_BGRA, GL_UNSIGNED_BYTE, textptr+sizeof(fb.image) )
	glubuild2dmipmaps( GL_TEXTURE_2D, GL_RGBA, timage->width, timage->height, GL_BGRA, GL_UNSIGNED_BYTE, textptr+sizeof(fb.image) )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR )
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR )
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)

end sub


sub gen_textures( textures() as gluint, iptrs() as fb.image ptr )

	iptrs(0) = imagecreate(128,128)
	line iptrs(0),(0,0)-(127,127), rgba(0,0,0,0)
	for x as integer = 0 to 15
		for y as integer = 0 to 15
			locate y+1, x+1
			print chr((x+y*16))
		next
	next

	for x as integer = 0 to 127
		for y as integer = 0 to 127
			dim as integer col = point(127-x,127-y )
			if col<>&hff000000 then
				pset iptrs(0),(127-x, y), col
			else
				pset iptrs(0),(127-x, y),&h00000000
			end if
		next
	next


	for i as integer = 1 to ubound(iptrs)
		iptrs(i) = imagecreate( iWidth, iHeight, rgba(0,0,0,0) )
	next

	line iptrs(1),(0,0)-(iWidth, iHeight),rgba(0,0,0,0),bf
	for i as integer = 30 to 0 step -1
		circle iptrs(1),(iWidth/2,iHeight/2), i, rgba( 178, 34, 34, 255 ),,,,f
	next

	line iptrs(2),(0,0)-(iWidth, iHeight),rgba(0,0,0,0),bf
	for i as integer = 30 to 0 step -1
		circle iptrs(2),(iWidth/2,iHeight/2), i, rgba( 178, 34, 34, 255 ),,,,f
	next

	circle iptrs(2), (48,16), 7, rgb(255, 255, 255),,,,f
	circle iptrs(2), (48,48), 7, rgb(255, 255, 255),,,,f
	circle iptrs(2), (48,16), 4, rgb(0, 0, 0),,,,f
	circle iptrs(2), (48,48), 4, rgb(0, 0, 0),,,,f



	for y as integer = 0 to iHeight-1
		for x as integer = 0 to iWidth-1
			dim as single grayBrick = 64+int(rnd*64)
			pset iptrs(3),(x,y),rgb(grayBrick,grayBrick,grayBrick)
		next
	next

	line iptrs(3),(0,0)-(64,0),rgb(6,6,0)
	line iptrs(3),(0,0)-(0,64),rgb(6,6,0)
	line iptrs(3),(0,16)-(64,16),rgb(6,6,0)
	line iptrs(3),(0,32)-(64,32),rgb(6,6,0)
	line iptrs(3),(0,48)-(64,48),rgb(6,6,0)
	line iptrs(3),(16,0)-(16,16),rgb(6,6,0)
	line iptrs(3),(48,16)-(48,32),rgb(6,6,0)
	line iptrs(3),(48,16)-(48,32),rgb(6,6,0)
	line iptrs(3),(16,32)-(16,48),rgb(6,6,0)
	line iptrs(3),(32,48)-(32,64),rgb(6,6,0)

	blur_image( iptrs(3), iptrs(3), 1 )

	'rainbow__________________________________________________
	'for i as integer = 0 to 250
	'	dim as integer rval = int(rnd*4)
	'	select case as const rval
	'		case 0
	'			circle iptrs(4), ( rnd*iWidth, rnd*iHeight ), 5+(rnd*15),rgb(64+rnd*128,0,0),,,,f
	'		case 1
	'			circle iptrs(4), ( rnd*iWidth, rnd*iHeight ), 5+(rnd*15),rgb(0,64+rnd*128,0),,,,f
	'		case 2
	'			circle iptrs(4), ( rnd*iWidth, rnd*iHeight ), 5+(rnd*15),rgb(0,0,64+rnd*128),,,,f
	'		case 3
	'			dim as integer gray = 16+int(rnd*128)
	'			circle iptrs(4), ( rnd*iWidth, rnd*iHeight ), 5+(rnd*15),rgb(gray, gray, gray),,,,f

	'	end select
	'next
	'
	'blur_image( iptrs(4), iptrs(4), 5 )
	'for y as integer = 0 to iptrs(4)->height-1
	'	for x as integer = 0 to iptrs(4)->width\2

	'		pset iptrs(4), ( (iptrs(4)->width-1)-x, y), point(x,y, iptrs(4))

	'	next
	'next
	

	'xor__________________________________________________
	'for y as integer = 0 to 63

	'	for x as integer = 0 to 63

	'		dim as integer col = x xor y

	'		pset iptrs(4), (x,y), rgb(col,col,col)

	'	next

	'next


	'grass__________________________________________________
	for y as integer = 0 to 64

		for x as integer = 0 to 64

			dim as integer col = x xor y

			pset iptrs(4), (x,y), rgb(0,32+int(rnd*32),0)

		next

	next
	
	blur_image( iptrs(4), iptrs(4), 1 )
	
	for y as integer = 0 to iptrs(4)->height-1
		for x as integer = 0 to iptrs(4)->width\2

			pset iptrs(4), ( (iptrs(4)->width-1)-x, y), point(x,y, iptrs(4))

		next
	next




end sub

sub create_gl_context()

	screencontrol FB.SET_GL_DEPTH_BITS, 24
	screencontrol FB.SET_GL_NUM_SAMPLES, 4
	screenres scr_w, scr_h, 32, 0, FB.GFX_OPENGL or FB.GFX_MULTISAMPLE or FB.GFX_HIGH_PRIORITY' or FB.GFX_FULLSCREEN

	glViewport(0, 0, scr_w, scr_h)
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	gluPerspective( 60, scr_w/scr_h, 1, 1000 )

	glDepthFunc( GL_LEQUAL )
	glEnable( GL_COLOR_MATERIAL )
	glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST )
	glPolygonMode ( GL_FRONT_AND_BACK, GL_FILL )
	glEnable( GL_CULL_FACE )
	glCullFace( GL_BACK )

	fnum = freefile
	open cons for output as #fnum
	gather_extensions()

end sub

sub render_target_struct.lock()

	if glBindFramebufferEXT then

		glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, this.fBuffer )

		glViewport( 0, 0, this.Width, this.Height )

	end if

end sub


sub render_target_struct.unlock()

	if glBindFramebufferEXT then

		glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, 0 )

		glViewport( 0, 0, scr_w, scr_h )

	end if

end sub


function render_target_struct.create( byref w as uinteger, byref h as uinteger, byref has_depth as integer, byref has_stencil as integer ) as integer

	dim as uinteger status = 0

	if glBindFramebufferEXT then

		with this
			'create a texture to attach to the framebuffer
			glGenTextures (1, @.texture)
			glBindTexture (GL_TEXTURE_2D, .texture)
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR)
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR)
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE)
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE)
			glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, W, H, 0, GL_RGBA, GL_UNSIGNED_BYTE, 0)
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
			glGenerateMipmapEXT(GL_TEXTURE_2D)
			dim as GlFloat Largest_Texture_Filter
			glGetFloatv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, @Largest_Texture_Filter)
			glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, Largest_Texture_Filter)

			'create framebuffer object and attach texture
			glGenFramebuffersEXT (1, @.fBuffer)
			glBindFramebufferEXT (GL_FRAMEBUFFER_EXT, .fBuffer)

			glFramebufferTexture2DEXT (GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, .texture, 0)
			glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_RENDERBUFFER_EXT, .texture)

			if has_depth <> 0 then

				glGenRenderbuffersEXT(1, @.dBuffer)
				glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, .dBuffer)
				glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, w, h)
				glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, .dBuffer)

				'after a bit of research, it seems this next bit of code wont even work without gl 3.0 headers/support.
				'elseif has_stencil <> 0 then
				'GL_UNSIGNED_INT_24_8_EXT 'this is the correct extension, seems our header is becoming dated.
				'GL_UNSIGNED_INT_24_8_NV 'our header only supplies this, and i don't feel like swigging it.

				'glGenRenderbuffersEXT( 1, @.dBuffer )
				'glBindRenderbufferEXT( GL_RENDERBUFFER_EXT, .dBuffer )
				'glRenderbufferStorageEXT( GL_RENDERBUFFER_EXT, GL_UNSIGNED_INT_24_8_NV, w, h )

				'glFramebufferRenderbufferEXT( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, .dBuffer )
				'glFramebufferRenderbufferEXT( GL_FRAMEBUFFER_EXT, GL_STENCIL_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, .dBuffer )

			end if


			status = glCheckFramebufferStatusEXT( GL_FRAMEBUFFER_EXT )

			if status <> GL_FRAMEBUFFER_COMPLETE_EXT then
				return 0
			end if

			this.width  = W
			this.height = H
			glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, 0 )
			return 1
		end with

	else
		return 0
	end if

end function


sub render_target_struct.destroy()

	with this

		if .fBuffer then
			glDeleteFramebuffersEXT( 1, @.fBuffer)
			glDeleteTextures( 1, @.texture )
		end if

		if .dBuffer then
			glDeleteRenderbuffersEXT(1, @.dBuffer)
		end if

	end with

end sub


sub set_ortho( byval W as integer, byval H as integer )
	glmatrixmode( Gl_PROJECTION )
	glpushmatrix()
	glloadidentity()
	glmatrixmode( Gl_MODELVIEW )
	glpushmatrix()
	glloadidentity()
	glortho( 0, W, 0, H, -1, 1 )
end sub


sub drop_ortho()
	glmatrixmode( Gl_PROJECTION )
	glpopmatrix()
	glmatrixmode( Gl_MODELVIEW )
	glpopmatrix()
end sub


sub gather_extensions()

	dim extensions as string
	screencontrol FB.GET_GL_EXTENSIONS, extensions

	dim as integer i, j

	do
		i+=1
		j=i
		dim as string tstring
		dim as string char
		do
			char = mid(extensions,j,1)
			tstring+=char
			j=j+1
			if char = " " then
				exit do
			end if
		loop while j<len(extensions)

		i = j-1
		print #fnum, tstring

	loop while i<len(extensions)



	if (instr(extensions, "GL_EXT_framebuffer_object") <> 0) then

		print #fnum, "GL_EXT_framebuffer_object is supported"

		_framebuffer_ = 1
		glGenFramebuffersEXT				= screenglproc("glGenFramebuffersEXT")
		glDeleteFramebuffersEXT			= screenglproc("glDeleteFramebuffersEXT")
		glBindFramebufferEXT				= screenglproc("glBindFramebufferEXT")
		glFramebufferTexture2DEXT		= screenglproc("glFramebufferTexture2DEXT")
		glFramebufferRenderbufferEXT	= screenglproc("glFramebufferRenderbufferEXT")
		glGenRenderbuffersEXT			= screenglproc("glGenRenderbuffersEXT")
		glBindRenderbufferEXT			= screenglproc("glBindRenderbufferEXT")
		glRenderbufferStorageEXT		= screenglproc("glRenderbufferStorageEXT")
		glDeleteRenderbuffersEXT		= screenglproc("glDeleteRenderbuffersEXT")
		glCheckFramebufferStatusEXT	= screenglproc("glCheckFramebufferStatusEXT")
		glGenerateMipmapEXT				= screenglproc("glGenerateMipmapEXT")

	else

		print #fnum, "GL_EXT_framebuffer_object is NOT supported"

	end if

end sub


sub init_light( byref light as Light_Struct, byref ambient as RGBALpha, byref diffuse as RGBAlpha, byref specular as RGBAlpha, byref position as vec4f, byref direction as vec3f )

	light.ambient = ambient
	light.diffuse = diffuse
	light.specular = specular
	light.position = position
	light.direction = direction

	glEnable( GL_LIGHT0 )
	glEnable( GL_LIGHTING )

	glLightfv( GL_LIGHT0, GL_AMBIENT, @light.ambient.r )
	glLightfv( GL_LIGHT0, GL_DIFFUSE, @light.diffuse.r )
	glLightfv( GL_LIGHT0, GL_SPECULAR, @light.specular.r )
	glLightfv( GL_LIGHT0, GL_POSITION, @light.position.x )
	glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL, GL_SEPARATE_SPECULAR_COLOR)

end sub


sub blur_image( byref dst as FB.IMAGE ptr, byref src as FB.IMAGE ptr, byref blur_level as integer )

	dim as uinteger ptr srcptr =  cast (uinteger ptr, src+1 )

	dim as uinteger ptr dstptr = cast (uinteger ptr, dst+1 )

	static as integer xstart

	static as integer xend

	static as integer ystart

	static as integer yend

	static as integer hits

	static as integer r

	static as integer g

	static as integer b

	static as integer c

	if blur_level<=0 then

		'wtf, why?
		exit sub

	end if

	for y as integer = 0 to dst->height - 1

		for x as integer = 0 to dst->width - 1

			xstart = x - blur_level

			xend = x + blur_level

			ystart = y - blur_level

			yend = y + blur_level

			if xstart<0 then

				xstart=0

			end if

			if xend>src->width-1 then

				xend=src->width-1

			end if

			if ystart<0 then

				ystart=0

			end if

			if yend>src->height-1 then

				yend=src->height-1

			end if

			hits=0

			r=0

			g=0

			b=0

			for y2 as integer = ystart to yend

				for x2 as integer = xstart to xend

					hits+=1

					c = *cast(uinteger ptr, cast(ubyte ptr, srcptr) + y2 * src->pitch + x2 * src->bpp)

					r += (c shr 16) and &hFF

					g += (c shr 8 ) and &hFF

					b += (c       ) and &hFF

				next

			next

			r\=hits

			g\=hits

			b\=hits

			*cast(uinteger ptr, cast(ubyte ptr, dstptr) + y * dst->pitch + x * dst->bpp) = rgb(r,g,b)

		next

	next

end sub